/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: ActivityTestHelper.java,v 249c1ad1b172 2010/08/08 11:03:21 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android;

import android.test.ActivityInstrumentationTestCase2;
import android.view.KeyEvent;
import com.jayway.android.robotium.solo.Solo;
import it.tidalwave.util.logging.Logger;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class ActivityTestHelper
  {
    private static final String CLASS = ActivityTestHelper.class.getName();
    private static final Logger logger = Logger.getLogger(CLASS);

    @Nonnull
    protected final ActivityInstrumentationTestCase2 instrumentationTestCase;

    @Nonnull
    protected final Solo solo;

    @Nonnull
    protected final TestHelper testHelper;

    protected ActivityTestHelper (final @Nonnull ActivityInstrumentationTestCase2 instrumentationTestCase,
                                  final @Nonnull Solo solo)
      {
        this.solo = solo;
        this.instrumentationTestCase = instrumentationTestCase;
        this.testHelper = new TestHelper(instrumentationTestCase, solo);
      }
    
    public void invokeMenuAction (final int id)
      {
        logger.info("invokeMenuAction(%d)", id);
        instrumentationTestCase.getInstrumentation().invokeMenuActionSync(solo.getCurrentActivity(), id, 0);
      }

    public void confirmDialog()
      {
        logger.info("confirmDialog()");
        // FIXME: assert that there's a dialog
        // FIXME: find the Ok button first!
        solo.sleep(500);
        testHelper.press(KeyEvent.KEYCODE_DPAD_CENTER);
      }
  }
